     //////////////////////////////////////////////////////////////////////
     //
     // Copyright (C) 1998 Analytic Services, Inc. (ANSER)
     //
     // Permission is hereby granted, free of charge, to any person
     // obtaining a copy of this software and associated documentation
     // files (the "Software"), to deal in the Software without
     // restriction, including without limitation the rights to use, copy,
     // modify, merge, publish, distribute, sublicense, and/or sell copies
     // of the Software, and to permit persons to whom the Software is
     // furnished to do so, subject to the following conditions:
     //
     // The above copyright notice and this permission notice shall be
     // included in all copies or substantial portions of the Software.
     //
     // THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
     // EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
     // MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
     // NONINFRINGEMENT.  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
     // HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
     // WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
     // OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
     // DEALINGS IN THE SOFTWARE.
     //
     //////////////////////////////////////////////////////////////////////

     package com.orbs.open1.mit.util;

     import java.io.*;
     import java.util.*;

     /*********************************************************************
     * <P>
     * @author                                                        
     *   <A HREF="http://www.alumni.caltech.edu/~croft">David W. Croft</A>
     * @version
     *   1997-10-05
     *********************************************************************/

     public class  PairVector implements Serializable {
     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     static final long  serialVersionUID = 1L;

     private Vector  key_Vector = new Vector ( );
     private Vector  val_Vector = new Vector ( );

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     public synchronized void  put ( Object  key, Object  value ) {
     //////////////////////////////////////////////////////////////////////
       key_Vector.addElement ( key   );
       val_Vector.addElement ( value );
     }
        
     public synchronized void  putAt (
       Object  key, Object  value, int  index ) {
     //////////////////////////////////////////////////////////////////////
       key_Vector.insertElementAt ( key  , index );
       val_Vector.insertElementAt ( value, index );
     }
        
     public synchronized Object  get ( Object  key ) {
     //////////////////////////////////////////////////////////////////////
       int  i = key_Vector.indexOf ( key );
       if ( i < 0 ) return null;
       return val_Vector.elementAt ( i );
     }
        
     public Object  keyAt ( int  index ) {
     //////////////////////////////////////////////////////////////////////
       return key_Vector.elementAt ( index );
     }
        
     public Object  valueAt ( int  index ) {
     //////////////////////////////////////////////////////////////////////
       return val_Vector.elementAt ( index );
     }
        
     public Enumeration  keys ( ) {
     //////////////////////////////////////////////////////////////////////
       return key_Vector.elements ( );
     }
        
     public Enumeration  values ( ) {
     //////////////////////////////////////////////////////////////////////
       return val_Vector.elements ( );
     }

     public int  size ( ) {
     //////////////////////////////////////////////////////////////////////
       return key_Vector.size ( );
     }
        
     public boolean  containsKey ( Object  o ) {
     //////////////////////////////////////////////////////////////////////
       return key_Vector.contains ( o );
     }
        
     public boolean  containsValue ( Object  o ) {
     //////////////////////////////////////////////////////////////////////
       return val_Vector.contains ( o );
     }
        
     public synchronized boolean  removeKey ( Object  o ) {
     //////////////////////////////////////////////////////////////////////
       int  i = key_Vector.indexOf ( o );
       if ( i < 0 ) return false;
       key_Vector.removeElementAt ( i );
       val_Vector.removeElementAt ( i );
       return true;
     }
        
     public synchronized boolean  removeValue ( Object  o ) {
     //////////////////////////////////////////////////////////////////////
       int  i = val_Vector.indexOf ( o );
       if ( i < 0 ) return false;
       key_Vector.removeElementAt ( i );
       val_Vector.removeElementAt ( i );
       return true;
     }
        
     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     }
