     //////////////////////////////////////////////////////////////////////
     // The contents of this file are subject to the Mozilla Public License
     // Version 1.1 (the "License"); you may not use this file except in
     // compliance with the License.  You may obtain a copy of the License
     // at http://www.mozilla.org/MPL/
     //
     // Software distributed under the License is distributed on an "AS IS"
     // basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.
     // See the License for the specific language governing rights and
     // limitations under the License.
     //
     // The Original Code is
     // "com.orbs.open1.mpl.app.chat.client.applet.ChatApplet",
     // created 1997-04-24.
     //
     // The Initial Developer of the Original Code is David Wallace Croft
     // (croft@alumni.caltech.edu, http://www.alumni.caltech.edu/~croft/).
     // Portions created by David Wallace Croft are
     // Copyright (C) 2000 David Wallace Croft.  All Rights Reserved.
     //
     // Contributor(s):
     //////////////////////////////////////////////////////////////////////

     package com.orbs.open1.mpl.app.chat.client.applet;

     import java.applet.*;
     import java.awt.*;
     import java.io.*;
     import java.net.*;
     import java.util.*;

     import com.orbs.open1.mpl.app.chat.ChatConstants;
     import com.orbs.open1.mpl.app.chat.client.*;

     /*********************************************************************
     * @version
     *   2000-04-24
     * @author
     *   <A HREF="http://www.alumni.caltech.edu/~croft">David W. Croft</A>
     *********************************************************************/

     public final class  ChatApplet extends Applet implements ChatConstants
     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     {

     public static final String  APPLET_TITLE
       = "ChatApplet \u00A9 1997-2000 David Wallace Croft";

     public static final String  APPLET_INFO
       = "\n" + APPLET_TITLE + "\n"
       + "croft@alumni.caltech.edu\n"
       + "http://www.alumni.caltech.edu/~croft/\n"
       + "Version 2000-04-24\n";

     public static final String  PARAM_SERVER_URL = "serverURL";

     private ChatClient  chatClient;

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     public void init ( )
     //////////////////////////////////////////////////////////////////////
     {
       try
       {
         System.out.println ( "ChatApplet.init()..." );

         setLayout ( null );

         String  serverURLString = getParameter ( PARAM_SERVER_URL );

         if ( serverURLString == null )
         {
           serverURLString = ChatConstants.DEFAULT_SERVER_URL_NAME;
         }
  
         URL  serverURL = new URL ( serverURLString );

         String  serverHost = serverURL.getHost ( );

         int     serverPort = serverURL.getPort ( );

         String  serverPath = serverURL.getFile ( );

System.out.println ( "serverPath = " + serverPath );
    
         chatClient = new ChatClient (
           serverHost, serverPort, serverPath, this );
       }
       catch ( Exception  ex )
       {
         ex.printStackTrace ( );
       }
     }

     public void  start ( )
     //////////////////////////////////////////////////////////////////////
     {
       try
       {
         System.out.println ( "ChatApplet.start()..." );

         chatClient.start ( );  
       }
       catch ( Exception  ex )
       {
         ex.printStackTrace ( );
       }
     }

     public void  stop ( )
     //////////////////////////////////////////////////////////////////////
     {
       try
       {
         System.out.println ( "ChatApplet.stop()..." );

         chatClient.stop ( );  
       }
       catch ( Exception  ex )
       {
         ex.printStackTrace ( );
       }
     }

     public void  destroy ( )
     //////////////////////////////////////////////////////////////////////
     {
       try
       {
         System.out.println ( "ChatApplet.destroy()..." );

         chatClient.destroy ( );  
       }
       catch ( Exception  ex )
       {
         ex.printStackTrace ( );
       }
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     public String  getAppletInfo ( )
     //////////////////////////////////////////////////////////////////////
     {
       return APPLET_INFO;
     }    

     public synchronized void  layout ( )
     //////////////////////////////////////////////////////////////////////
     {
       if ( chatClient == null )
       {
         return;
       }

       Rectangle  bounds = bounds ( );

       try
       {
         chatClient.reshape (
           bounds.x, bounds.y, bounds.width, bounds.height );
       }
       catch ( Exception  e )
       {
         e.printStackTrace ( );
       }
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     }
