     //////////////////////////////////////////////////////////////////////
     // The contents of this file are subject to the Mozilla Public License
     // Version 1.1 (the "License"); you may not use this file except in
     // compliance with the License.  You may obtain a copy of the License
     // at http://www.mozilla.org/MPL/
     //
     // Software distributed under the License is distributed on an "AS IS"
     // basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.
     // See the License for the specific language governing rights and
     // limitations under the License.
     //
     // The Original Code is
     // "com.orbs.open1.mpl.app.chat.command.ChatCommandMove",
     // created 1999-12-18.
     //
     // The Initial Developer of the Original Code is David Wallace Croft
     // (croft@alumni.caltech.edu, http://www.alumni.caltech.edu/~croft/).
     // Portions created by David Wallace Croft are
     // Copyright (C) 1999 David Wallace Croft.  All Rights Reserved.
     //
     // Contributor(s):
     //////////////////////////////////////////////////////////////////////

     package com.orbs.open1.mpl.app.chat.server.command;

     import java.awt.Point;
     import java.util.*;

     import com.orbs.open1.mpl.app.chat.*;
     import com.orbs.open1.mpl.app.chat.server.*;

     /*********************************************************************
     *
     * <P>
     *
     * @author
     *   <A HREF="http://www.alumni.caltech.edu/~croft">David W. Croft</A>
     * @version
     *   2000-03-28
     *********************************************************************/

     public final class  ChatCommandMove implements ChatCommand
     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     {

     private final ChatEntityID  chatEntityID;

     private final ChatModel     chatModel;

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     public  ChatCommandMove (
       ChatEntityID  chatEntityID,
       ChatModel     chatModel )
     //////////////////////////////////////////////////////////////////////
     {
       this.chatEntityID = chatEntityID;

       this.chatModel    = chatModel;
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     public ChatMessage  process ( ChatMessage  chatMessage )
     //////////////////////////////////////////////////////////////////////
     {
       String [ ]  values = chatMessage.getValues ( );

       ChatThingID  chatThingID = new ChatThingID ( values [ 0 ] );

       int  x = Integer.parseInt ( values [ 1 ] );

       int  y = Integer.parseInt ( values [ 2 ] );

       chatModel.move ( chatThingID, new Point ( x, y ) );

       return null;

/*
       return new ChatMessage (
         ChatMessage.CODE_RESPONSE_MOVE,
         chatEntityID,
         new String [ ] {
           chatThingID.toString ( ),
           Integer.toString ( x ),
           Integer.toString ( y ) } );
*/
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     }
