     //////////////////////////////////////////////////////////////////////
     // The contents of this file are subject to the Mozilla Public License
     // Version 1.1 (the "License"); you may not use this file except in
     // compliance with the License.  You may obtain a copy of the License
     // at http://www.mozilla.org/MPL/
     //
     // Software distributed under the License is distributed on an "AS IS"
     // basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.
     // See the License for the specific language governing rights and
     // limitations under the License.
     //
     // The Original Code is
     // "com.orbs.open1.mpl.app.chat.command.ChatCommandThing",
     // created 2000-01-23.
     //
     // The Initial Developer of the Original Code is David Wallace Croft
     // (croft@alumni.caltech.edu, http://www.alumni.caltech.edu/~croft/).
     // Portions created by David Wallace Croft are
     // Copyright (C) 1999 David Wallace Croft.  All Rights Reserved.
     //
     // Contributor(s):
     //////////////////////////////////////////////////////////////////////

     package com.orbs.open1.mpl.app.chat.server.command;

     import java.awt.Point;
     import java.util.*;

     import com.orbs.open1.mpl.app.chat.*;
     import com.orbs.open1.mpl.app.chat.server.*;

     /*********************************************************************
     * Creates a new ChatThing within the ChatModel.
     *
     * <P>
     *
     * @author
     *   <A HREF="http://www.alumni.caltech.edu/~croft">David W. Croft</A>
     * @version
     *   2000-01-23
     *********************************************************************/

     public final class  ChatCommandThing implements ChatCommand
     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     {

     private final ChatEntityID  chatEntityID;

     private final ChatModel     chatModel;

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     public  ChatCommandThing (
       ChatEntityID  chatEntityID,
       ChatModel     chatModel )
     //////////////////////////////////////////////////////////////////////
     {
       this.chatEntityID = chatEntityID;

       this.chatModel    = chatModel;
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     public ChatMessage  process ( ChatMessage  chatMessage )
     //////////////////////////////////////////////////////////////////////
     {
       ChatEntityID  ownerChatEntityID = chatMessage.getChatEntityID ( );

       if ( ownerChatEntityID == null )
       {
         throw new IllegalArgumentException ( "null chatEntityID" );
       }

       String [ ]  values = chatMessage.getValues ( );

       if ( values == null )
       {
         throw new IllegalArgumentException ( "null values" );
       }

       if ( values.length < 3 )
       {
         throw new IllegalArgumentException ( "values.length < 3" );
       }

       String  imageURLName = values [ 0 ];

       int  x = Integer.parseInt ( values [ 1 ] );

       int  y = Integer.parseInt ( values [ 2 ] );

       ChatThingID  chatThingID = chatModel.createChatThingID (
         ownerChatEntityID, new Point ( x, y ), imageURLName );

       values = new String [ ] { chatThingID.toString ( ) };

       return new ChatMessage (
         ChatMessage.CODE_RESPONSE_THING,
         chatEntityID,
         values );
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     }
