     //////////////////////////////////////////////////////////////////////
     // The contents of this file are subject to the Mozilla Public License
     // Version 1.1 (the "License"); you may not use this file except in
     // compliance with the License.  You may obtain a copy of the License
     // at http://www.mozilla.org/MPL/
     //
     // Software distributed under the License is distributed on an "AS IS"
     // basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.
     // See the License for the specific language governing rights and
     // limitations under the License.
     //
     // The Original Code is "com.orbs.open1.mpl.app.text.ReplaceText",
     // created 1999-08-15.
     //
     // The Initial Developer of the Original Code is David Wallace Croft
     // (croft@alumni.caltech.edu, http://www.alumni.caltech.edu/~croft/).
     // Portions created by David Wallace Croft are
     // Copyright (C) 1999 David Wallace Croft.  All Rights Reserved.
     //
     // Contributor(s):
     //////////////////////////////////////////////////////////////////////

     package com.orbs.open1.mpl.app.text;

     import java.io.*;

     import com.orbs.open1.mpl.io.FileLib;

     /*********************************************************************
     * Replaces text in a file.
     *
     * <P>
     *
     * Command line:<BR>
     * java com.orbs.app.util.ReplaceText fileName oldString newString
     *
     * <P>
     *
     * @version
     *   1999-08-15
     * @author
     *   <A HREF="http://www.alumni.caltech.edu/~croft/">David W. Croft</A>
     *********************************************************************/

     public class  ReplaceText
     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     {

     public static void  main ( String [ ]  args )
       throws FileNotFoundException, IOException
     //////////////////////////////////////////////////////////////////////
     {
       if ( args.length != 3 )
       {
         System.out.println ( "java com.orbs.app.util.ReplaceText "
           + "fileName oldString newString" );
         return;
       }
       replaceText ( args [ 0 ], args [ 1 ], args [ 2 ] );
     }

     /*********************************************************************
     * Calls FileLib.replaceStrings(file, oldString, newString).
     *********************************************************************/
     public static void  replaceText (
       String  fileName, String  oldString, String  newString )
       throws FileNotFoundException, IOException
     //////////////////////////////////////////////////////////////////////
     {
       File  file = new File ( fileName );
       System.out.print ( file.getCanonicalPath ( ) + " " );
       System.out.println (
         FileLib.replaceStrings ( file, oldString, newString )
         ? "changed" : "unchanged" );
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     }
