     //////////////////////////////////////////////////////////////////////
     // The contents of this file are subject to the Mozilla Public License
     // Version 1.1 (the "License"); you may not use this file except in
     // compliance with the License.  You may obtain a copy of the License
     // at http://www.mozilla.org/MPL/
     //
     // Software distributed under the License is distributed on an "AS IS"
     // basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.
     // See the License for the specific language governing rights and
     // limitations under the License.
     //
     // The Original Code is "com.orbs.open1.mpl.io.LinePrintStreamQueue",
     // created 1997-04-26.
     //
     // The Initial Developer of the Original Code is David Wallace Croft
     // (croft@alumni.caltech.edu, http://www.alumni.caltech.edu/~croft/).
     // Portions created by David Wallace Croft are
     // Copyright (C) 1999 David Wallace Croft.  All Rights Reserved.
     //
     // Contributor(s):
     //////////////////////////////////////////////////////////////////////

     package com.orbs.open1.mpl.io;

     import com.orbs.open1.mpl.util.Queue;
     import java.io.PrintStream;

     /*********************************************************************
     * @author
     *   <A HREF="http://www.alumni.caltech.edu/~croft">David W. Croft</A>
     * @version
     *   1997-04-26
     *********************************************************************/

     public class  LinePrintStreamQueue extends Queue implements Runnable {
     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     private PrintStream  printStream;
     private Thread       thread;

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     public  LinePrintStreamQueue ( PrintStream  printStream ) {
     //////////////////////////////////////////////////////////////////////
       this.printStream = printStream;
     }

     /*********************************************************************
     * Starts a Thread of this.
     *********************************************************************/
     public void  start ( ) {
     //////////////////////////////////////////////////////////////////////
       if ( thread == null ) ( thread = new Thread ( this ) ).start ( );
     }

     /*********************************************************************
     * Removes outgoing lines from the queue and sends them down the
     * printStream via println().
     * <P>
     * If null is removed from the Queue or the printStream has an
     * error, calls setRejecting(true) and then stop().
     *********************************************************************/
     public void  run ( ) {
     //////////////////////////////////////////////////////////////////////
       while ( true ) {
         String  line = ( String ) remove ( );
         if ( line != null ) printStream.println ( line );
         if ( ( line == null ) || printStream.checkError ( ) ) {
           setRejecting ( true );
           stop ( );
         }
       }
     }

     /*********************************************************************
     * Stops the Thread of this.<BR>
     * You may wish to call setRejecting(true) after calling this
     * so that the add() method will reject any incoming lines and return
     * false.
     *********************************************************************/
     public void  stop ( ) {
     //////////////////////////////////////////////////////////////////////
       if ( thread != null ) {
         thread.stop ( );
         thread = null;
       }
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     }
