     //////////////////////////////////////////////////////////////////////
     // The contents of this file are subject to the Mozilla Public License
     // Version 1.1 (the "License"); you may not use this file except in
     // compliance with the License.  You may obtain a copy of the License
     // at http://www.mozilla.org/MPL/
     //
     // Software distributed under the License is distributed on an "AS IS"
     // basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.
     // See the License for the specific language governing rights and
     // limitations under the License.
     //
     // The Original Code is "com.orbs.open1.mpl.net.http.HttpLib",
     // created 1999-12-19.
     //
     // The Initial Developer of the Original Code is David Wallace Croft
     // (croft@alumni.caltech.edu, http://www.alumni.caltech.edu/~croft/).
     // Portions created by David Wallace Croft are
     // Copyright (C) 1999 David Wallace Croft.  All Rights Reserved.
     //
     // Contributor(s):
     //////////////////////////////////////////////////////////////////////

     package com.orbs.open1.mpl.j1d1.net.http;

     import java.io.*;
     import java.net.*;

     /*********************************************************************
     *
     * HTTP operations.
     *
     * <P>
     *
     * @author
     *   <A HREF="http://www.alumni.caltech.edu/~croft">David W. Croft</A>
     * @version
     *   2000-04-23
     *********************************************************************/

     public final class  HttpLib
     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     {

     private  HttpLib ( ) { }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     public static void  main ( String [ ]  args ) throws Exception
     //////////////////////////////////////////////////////////////////////
     {
       String  host = args [ 0 ];

       String  path = args [ 1 ];

       byte [ ]  bytes = args [ 2 ].getBytes ( "US-ASCII" );

       System.out.println ( post ( host, path, bytes ) );
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     public static int  post (
       String    host,
       String    path,
       byte [ ]  bytes )
       throws IOException
     //////////////////////////////////////////////////////////////////////
     {
       return post ( host, 80, path, "HttpLib/1.00",
         "application/x-www-form-urlencoded", bytes );
     }

     public static int  post (
       String    host,
       int       port,
       String    path,
       String    userAgent,
       byte [ ]  bytes )
       throws IOException
     //////////////////////////////////////////////////////////////////////
     {
       return post ( host, port, path, userAgent,
         "application/x-www-form-urlencoded", bytes );
     }

     public static int  post (
       String    host,
       int       port,
       String    path,
       String    userAgent,
       String    contentType,
       byte [ ]  bytes )
       throws IOException
     //////////////////////////////////////////////////////////////////////
     {
       HttpConnection  httpConnection = new HttpConnection (
         host, port, path,userAgent, contentType, bytes, null );

       httpConnection.post ( );

       return httpConnection.getResponseCode ( );
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     }
