     //////////////////////////////////////////////////////////////////////
     // The contents of this file are subject to the Mozilla Public License
     // Version 1.1 (the "License"); you may not use this file except in
     // compliance with the License.  You may obtain a copy of the License
     // at http://www.mozilla.org/MPL/
     //
     // Software distributed under the License is distributed on an "AS IS"
     // basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.
     // See the License for the specific language governing rights and
     // limitations under the License.
     //
     // The Original Code is
     // "com.orbs.open1.mpl.app.chat.ChatMessagePusher",
     // created 1999-12-19.
     //
     // The Initial Developer of the Original Code is David Wallace Croft
     // (croft@alumni.caltech.edu, http://www.alumni.caltech.edu/~croft/).
     // Portions created by David Wallace Croft are
     // Copyright (C) 1999 David Wallace Croft.  All Rights Reserved.
     //
     // Contributor(s):
     //////////////////////////////////////////////////////////////////////

     package com.orbs.open1.mpl.j1d1.net.http.msg;

     import java.io.*;
     import java.net.URL;

     import com.orbs.open1.mpl.j1d1.net.http.HttpLib;
     import com.orbs.open1.mpl.j1d1.util.queue.*;

     import com.orbs.open1.mpl.io.Encoder;
     import com.orbs.open1.mpl.role.Consumer;

     /*********************************************************************
     * Pulls Objects out of a Queue and HTTP POSTs them.
     * 
     * <P>
     *
     * @author
     *   <A HREF="http://www.alumni.caltech.edu/~croft">David W. Croft</A>
     * @version
     *   2000-04-23
     *********************************************************************/

     public final class  HttpMessagePusher implements Consumer
     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     {

     private final QueuePuller  outgoingQueuePuller;

     private final String       host;

     private final int          port;

     private final String       path;

     private final String       userAgent;

     private final Encoder      encoder;

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     public  HttpMessagePusher (
       Queue    outgoingQueue,
       String   host,
       int      port,
       String   path,
       String   userAgent,
       Encoder  encoder )
     //////////////////////////////////////////////////////////////////////
     {
       outgoingQueuePuller = new QueuePuller ( outgoingQueue, this );

       this.host           = host;

       this.port           = port;

       this.path           = path;

       this.userAgent      = userAgent;

       this.encoder        = encoder;
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     public void  consume ( Object  o )
     //////////////////////////////////////////////////////////////////////
     {
       try
       {
         int  responseCode = HttpLib.post ( host, port, path, userAgent,
           encoder.encode ( o ) );

System.out.println ( "HttpMessagePusher:  " + responseCode );

       }
       catch ( Exception  ex )
       {
         ex.printStackTrace ( );
       }
     }

     public void  start ( )
     //////////////////////////////////////////////////////////////////////
     {
       outgoingQueuePuller.start ( );
     }

     public void  stop ( )
     //////////////////////////////////////////////////////////////////////
     {
       outgoingQueuePuller.stop ( );
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     }
