     //////////////////////////////////////////////////////////////////////
     // The contents of this file are subject to the Mozilla Public License
     // Version 1.1 (the "License"); you may not use this file except in
     // compliance with the License.  You may obtain a copy of the License
     // at http://www.mozilla.org/MPL/
     //
     // Software distributed under the License is distributed on an "AS IS"
     // basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.
     // See the License for the specific language governing rights and
     // limitations under the License.
     //
     // The Original Code is "com.orbs.open1.mpl.util.id.ID"
     // created 1999-04-08.
     //
     // The Initial Developer of the Original Code is David Wallace Croft
     // (croft@alumni.caltech.edu, http://www.alumni.caltech.edu/~croft/).
     // Portions created by David Wallace Croft are
     // Copyright (C) 1999 David Wallace Croft.  All Rights Reserved.
     //
     // Contributor(s):
     //////////////////////////////////////////////////////////////////////

     package com.orbs.open1.mpl.j1d1.util.id;

     import java.io.Serializable;

     /*********************************************************************
     * An ID is used for consistent cross-process identification.
     *
     * <P>
     *
     * ID objects are useful for identifying, by equality, distributed
     * and persistent objects (space and time, respectively).
     *
     * <P>
     *
     * An object that implements ID has the following characteristics:
     *
     * <UL>
     * <LI> immutable;
     * <LI> Serializable and deeply Cloneable; and
     * <LI> results from the methods equals() and hashCode() are not based
     *      upon transient data and are consistent across processes.
     * </UL>
     *
     * <P>
     *
     * @see
     *   IntID
     * @see
     *   StringID
     * @version
     *   2000-01-16
     * @author
     *   <A HREF="http://www.alumni.caltech.edu/~croft/">David W. Croft</A>
     *********************************************************************/

     public interface  ID extends Cloneable, Serializable
     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     {

     public boolean  equals ( Object  other );

     public int  hashCode ( );

     public Object  clone ( );

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     }
