     //////////////////////////////////////////////////////////////////////
     // The contents of this file are subject to the Mozilla Public License
     // Version 1.1 (the "License"); you may not use this file except in
     // compliance with the License.  You may obtain a copy of the License
     // at http://www.mozilla.org/MPL/
     //
     // Software distributed under the License is distributed on an "AS IS"
     // basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.
     // See the License for the specific language governing rights and
     // limitations under the License.
     //
     // The Original Code is "com.orbs.open1.mpl.media.sound.midi.MidiTest"
     // created 1999-11-07.
     //
     // The Initial Developer of the Original Code is David Wallace Croft
     // (croft@alumni.caltech.edu, http://www.alumni.caltech.edu/~croft/).
     // Portions created by David Wallace Croft are
     // Copyright (C) 1999 David Wallace Croft.  All Rights Reserved.
     //
     // Contributor(s):
     //////////////////////////////////////////////////////////////////////

     package com.orbs.open1.mpl.media.sound.midi;

     import javax.media.sound.midi.*;

     /*********************************************************************
     * Tests all MIDI Instruments.
     *
     * <P>
     *
     * @author
     *   <A HREF="http://www.alumni.caltech.edu/~croft/">David W. Croft</A>
     * @version
     *   1999-11-07
     *********************************************************************/
     public final class  MidiTest
     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     {

     private  MidiTest ( ) { }

     //////////////////////////////////////////////////////////////////////
     // Static methods
     //////////////////////////////////////////////////////////////////////

     public static void  main ( String [ ]  args )
       throws MidiUnavailableException
     //////////////////////////////////////////////////////////////////////
     {
       Sequencer  sequencer = MidiSystem.getSequencer ( null );

       Synthesizer  synthesizer = MidiSystem.getSynthesizer ( null );

       synthesizer.open ( );

       Instrument [ ]  instruments
         = synthesizer.getDefaultSoundbank ( ).getInstruments ( );

       MidiChannel [ ]  midiChannels = synthesizer.getChannels ( );

       for ( int  instrumentIndex = 0;
             instrumentIndex < instruments.length;
             instrumentIndex++ )
       {
         Instrument  instrument = instruments [ instrumentIndex ];

         System.out.println ( instrument.getName ( ) );

         synthesizer.loadInstrument ( instrument );

         midiChannels [ 0 ].programChange ( instrumentIndex );

         int  velocity = 64;

         for ( int  noteNumber = 0; noteNumber < 128; noteNumber++ )
         {
           midiChannels [ 0 ].noteOn ( noteNumber, velocity );

           try
           {
             Thread.sleep ( 100 );
           }
           catch ( InterruptedException  e )
           {
           }

           midiChannels [ 0 ].noteOff ( noteNumber );

           try
           {
             Thread.sleep ( 100 );
           }
           catch ( InterruptedException  e )
           {
           }

         }
       }

       synthesizer.close ( );

       sequencer.close ( );
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     }
