     //////////////////////////////////////////////////////////////////////
     // The contents of this file are subject to the Mozilla Public License
     // Version 1.1 (the "License"); you may not use this file except in
     // compliance with the License.  You may obtain a copy of the License
     // at http://www.mozilla.org/MPL/
     //
     // Software distributed under the License is distributed on an "AS IS"
     // basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.
     // See the License for the specific language governing rights and
     // limitations under the License.
     //
     // The Original Code is "com.orbs.open1.mpl.security.DigestLib",
     // created 1998-10-04.
     //
     // The Initial Developer of the Original Code is David Wallace Croft
     // (croft@alumni.caltech.edu, http://www.alumni.caltech.edu/~croft/).
     // Portions created by David Wallace Croft are
     // Copyright (C) 1999 David Wallace Croft.  All Rights Reserved.
     //
     // Contributor(s):
     //////////////////////////////////////////////////////////////////////

     package com.orbs.open1.mpl.security;

     import java.io.*;
     import java.security.*;

     /*********************************************************************
     *
     * Static method library for creating message digests of byte streams.
     *
     * @version
     *   1998-10-04
     * @author
     *   <A HREF="http://www.alumni.caltech.edu/~croft/">David W. Croft</A>
     *********************************************************************/

     public final class  DigestLib
     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     {

     private  DigestLib ( ) { }

     public static byte [ ]  digest (
       InputStream  inputStream, String  algorithm )
       throws IOException, NoSuchAlgorithmException
     //////////////////////////////////////////////////////////////////////
     {
       InputStream  in = new BufferedInputStream ( inputStream );
       MessageDigest  digest = MessageDigest.getInstance ( algorithm );
       int  i;
       while ( ( i = in.read ( ) ) > -1 ) digest.update ( ( byte ) i );
       in.close ( );
       return digest.digest ( );
     }

     public static byte [ ]  digest (
       File  file, String  algorithm )
       throws IOException, NoSuchAlgorithmException
     //////////////////////////////////////////////////////////////////////
     {
       return digest ( new FileInputStream ( file ), algorithm );
     }

     public static byte [ ]  digest ( File  file )
       throws IOException, NoSuchAlgorithmException
     //////////////////////////////////////////////////////////////////////
     {
       return digest ( file, "SHA-1" );
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     }
