     //////////////////////////////////////////////////////////////////////
     // The contents of this file are subject to the Mozilla Public License
     // Version 1.1 (the "License"); you may not use this file except in
     // compliance with the License.  You may obtain a copy of the License
     // at http://www.mozilla.org/MPL/
     //
     // Software distributed under the License is distributed on an "AS IS"
     // basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.
     // See the License for the specific language governing rights and
     // limitations under the License.
     //
     // The Original Code is "com.orbs.open1.mpl.text.ParseLib",
     // created 1999-08-15.
     //
     // The Initial Developer of the Original Code is David Wallace Croft
     // (croft@alumni.caltech.edu, http://www.alumni.caltech.edu/~croft/).
     // Portions created by David Wallace Croft are
     // Copyright (C) 1999 David Wallace Croft.  All Rights Reserved.
     //
     // Contributor(s):
     //////////////////////////////////////////////////////////////////////

     package com.orbs.open1.mpl.text;

     /*********************************************************************
     *
     * A collection of static methods to parse primitive types.
     * 
     * @version
     *   1999-08-15
     * @author
     *   <A HREF="http://www.alumni.caltech.edu/~croft/">David W. Croft</A>
     *********************************************************************/

     public final class  ParseLib
     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     {

     private  ParseLib ( ) { }

     public static void  main ( String [ ]  args )
     //////////////////////////////////////////////////////////////////////
     {
       System.out.println ( parseDouble ( null    , 1968.0 ) );
       System.out.println ( parseDouble ( "1968.0", 1974.0 ) );
       System.out.println ( parseDouble ( "abcdef", 1968.0 ) );
     }

     /*********************************************************************
     * Parses a double out of a String.
     *
     * @param  def
     *   Default value returned if unable to parse the String.
     *********************************************************************/
     public static double  parseDouble ( String  s, double  def )
     //////////////////////////////////////////////////////////////////////
     {
       if ( s == null ) return def;

       try
       {
         return Double.valueOf ( s ).doubleValue ( );
       }
       catch ( NumberFormatException  ex )
       {
         return def;
       }
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     }
