     //////////////////////////////////////////////////////////////////////
     // The contents of this file are subject to the Mozilla Public License
     // Version 1.1 (the "License"); you may not use this file except in
     // compliance with the License.  You may obtain a copy of the License
     // at http://www.mozilla.org/MPL/
     //
     // Software distributed under the License is distributed on an "AS IS"
     // basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.
     // See the License for the specific language governing rights and
     // limitations under the License.
     //
     // The Original Code is
     // "com.orbs.open1.mpl.util.filemap.FileMapEntry",
     // created 1999-04-03.
     //
     // The Initial Developer of the Original Code is David Wallace Croft
     // (croft@alumni.caltech.edu, http://www.alumni.caltech.edu/~croft/).
     // Portions created by David Wallace Croft are
     // Copyright (C) 1999 David Wallace Croft.  All Rights Reserved.
     //
     // Contributor(s):
     //////////////////////////////////////////////////////////////////////

     package com.orbs.open1.mpl.util.filemap;

     import java.io.*;
     import java.util.*;

     /*********************************************************************
     * This Map.Entry is required for the AbstractMap implementation of
     * FileMap.
     *
     * @see
     *   FileMapEntryIterator
     * @see
     *   FileMapEntrySet
     * @see
     *   java.util.Map.Entry
     *
     * @version
     *   1999-04-03
     * @author
     *   <A HREF="http://www.alumni.caltech.edu/~croft/">David W. Croft</A>
     *********************************************************************/

     public class  FileMapEntry implements Map.Entry
     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     {

     private File    rootDirectory;
     private String  filename;

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     public  FileMapEntry ( File  rootDirectory, String  filename )
     //////////////////////////////////////////////////////////////////////
     {
       this.rootDirectory = rootDirectory;
       this.filename      = filename;
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////

     public boolean  equals ( Object  o )
     //////////////////////////////////////////////////////////////////////
     {
       if ( o == null ) return false;

       if ( !o.getClass ( ).equals ( this.getClass ( ) ) ) return false;

       FileMapEntry  other = ( FileMapEntry ) o;

       if ( !filename.equals ( other.filename ) ) return false;

       if ( !rootDirectory.equals ( other.rootDirectory ) ) return false;

       if ( hashCode ( ) != other.hashCode ( ) ) return false;

       return true;
     }

     public Object  getKey ( )
     //////////////////////////////////////////////////////////////////////
     {
       return filename;
     }

     public Object  getValue ( )
     //////////////////////////////////////////////////////////////////////
     {
       try
       {
         return new FileInputStream (
           new File ( rootDirectory, filename ) );
       }
       catch ( FileNotFoundException  ex )
       {
         return null;
       }
     }

     public int  hashCode ( )
     //////////////////////////////////////////////////////////////////////
     {
       return filename.hashCode ( );
     }

     public Object  setValue ( Object  value )
     //////////////////////////////////////////////////////////////////////
     {
       throw new UnsupportedOperationException ( );
     }

     //////////////////////////////////////////////////////////////////////
     //////////////////////////////////////////////////////////////////////
     }
